<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of FsPhoneTrackingControllerV2
 *
 * @author rudyard
 */
class FsPhoneTrackingControllerV2 
{
    public function __construct()
    {
        add_action( 'init', array(&$this, 'init'));   
        add_shortcode( 'fs_ibp_get_number_v2', array(&$this, 'fs_ibp_get_number_v2' ));   
    }
    
    function init()
    {        
        global $fsf_referrer;
        global $fsf_base_uri;
        
        if(isset($_COOKIE['ibp_referrer']) && strlen($_COOKIE['ibp_referrer'])>0)
        {
                $fsf_referrer = $_COOKIE['ibp_referrer'];
        }
        else
        {
                $fsf_referrer = $_SERVER['HTTP_REFERER'];
                setcookie('ibp_referrer', $fsf_referrer, 0, '/');
        }
        if(isset($_COOKIE['ibp_baseuri']) && strlen($_COOKIE['ibp_baseuri'])>0)
        {
                $fsf_base_uri = $_COOKIE['ibp_baseuri'];
        }
        else
        {
                $fsf_base_uri = $this->get_url();
                setcookie('ibp_baseuri', $fsf_base_uri, 0, '/');
        }
    }
    function fs_ibp_get_number_v2($atts)
    {
        global $fsf_referrer;
        global $fsf_base_uri;
        global $fsf_log_ids;
        global $fs_visitor;
        
        extract( shortcode_atts( array(
                'id' => '',
                'api_key' => '',
                'set_id' => ''
        ), $atts ) );
        
        $str = '';
        try
        {
            if(!isset($fsf_log_ids))
            {
                $fsf_log_ids = array();
            }
            $fields = array('action' => 'sourcetrak.get_number', 'ibp_api_version' => 2);
            $fields['api_key'] = $api_key;
            $fields['set_id'] = $set_id;
            if(isset($fsf_log_ids[$set_id]))
            {
                $fields['log_id'] = $fsf_log_ids[$set_id];
            }
            $fields['referrer'] = $fsf_referrer;
            $fields['baseURI'] = $fsf_base_uri;
            $fields['_ibp_unique_id'] = $fs_visitor;
            $xml = FsForms::CurlGetContents('https://secure.ifbyphone.com/ibp_api.php', $fields);
            $ibp = new SimpleXMLElement($xml);
            if(isset($ibp->data))
            {
                if(isset($ibp->data->sourceTrak))
                {
                    $fsf_log_ids[$set_id] = $ibp->data->sourceTrak->log_id; 
                    $str .= $this->format_phone($ibp->data->sourceTrak->number);
                }
                else
                {
                    throw new Exception('SourceTrak Not Set');
                }
            }
            else
            {
                throw new Exception('Data Not Set');
            }
        } 
        catch (Exception $ex)
        {
            $phone = get_option('fallback_phone');
            if(strlen($phone)>0)
            {
                $str .= $phone;
            }
            else
            {
                $str .= 'Error Displaying Phone';
            }
        }
        return $str;
    }
    
    private function get_url()
    {
        $protocol = ($_SERVER['HTTPS'] && $_SERVER['HTTPS'] != "off") ? "https" : "http";
        return $protocol . "://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
    }
    
    function format_phone($phone)
    {
        $phone = preg_replace("/[^0-9]/", "", $phone);

        if(strlen($phone) == 7)
        {
            $phone = preg_replace("/([0-9]{3})([0-9]{4})/", "$1-$2", $phone);
        }
        elseif(strlen($phone) == 10)
        {
            $phone = preg_replace("/([0-9]{3})([0-9]{3})([0-9]{4})/", "($1) $2-$3", $phone);
        }
        return $phone;
    }
}

?>
