

var FsAnalytics = new function(){
    this.event_queue = [];
    this.processing = false;
    
    this.ProcessQueue = function()
    {
        var data = this.event_queue.shift();
        if(data)
        {
            FsAnalytics.processing = true;
            jQuery.ajax({
                type: "POST",
                url: FsCurrentAnalytics.Url,
                data: data.arg,
                success:function(result) {
                    FsAnalytics.processing = false;
                    FsAnalytics.ProcessQueue();
                    
                    if(data.callback)
                    {
                        data.callback();
                    }
                },
                error:function(xhr) {
                    FsAnalytics.processing = false;
                    FsAnalytics.ProcessQueue();
                }
            });
        }
    };
    this.AddToQueue = function(arg, callback)
    {
        var event = { arg: arg, callback: callback };
        this.event_queue.push(event);
        if(!FsAnalytics.processing)
        {
            this.ProcessQueue();
        }
    };
    
    this.PageView = function() {
        var args = { 
            Parent: -1,
            Type: 1,
            Website: FsCurrentAnalytics.Website,
            RemoteAddress: FsCurrentAnalytics.RemoteAddress,
            HttpReferer: FsCurrentAnalytics.HttpReferer,
            RequestUri: FsCurrentAnalytics.RequestUri,
            UserAgent: FsCurrentAnalytics.UserAgent,
            Visitor: FsCurrentAnalytics.Visitor
        };
        this.AddToQueue(args, null);            
    };
    
    this.FormView = function(form) {
        var args = { 
            Type: 2,
            Parent: form,
            Website: FsCurrentAnalytics.Website,
            RemoteAddress: FsCurrentAnalytics.RemoteAddress,
            HttpReferer: FsCurrentAnalytics.HttpReferer,
            RequestUri: FsCurrentAnalytics.RequestUri,
            UserAgent: FsCurrentAnalytics.UserAgent,
            Visitor: FsCurrentAnalytics.Visitor
        };
        this.AddToQueue(args, null);
    };
    
    this.FormUpdate = function(field, value) {
        var args = { 
            Type: 3,
            Parent: field,           
            Value: value,
            Website: FsCurrentAnalytics.Website,
            RemoteAddress: FsCurrentAnalytics.RemoteAddress,
            HttpReferer: FsCurrentAnalytics.HttpReferer,
            RequestUri: FsCurrentAnalytics.RequestUri,
            UserAgent: FsCurrentAnalytics.UserAgent,
            Visitor: FsCurrentAnalytics.Visitor
        };
        this.AddToQueue(args, null);
    };
    
    this.FormCompletion = function(lead, finish) {
        var args = { 
            Type: 4,
            Parent: lead,
            Website: FsCurrentAnalytics.Website,
            RemoteAddress: FsCurrentAnalytics.RemoteAddress,
            HttpReferer: FsCurrentAnalytics.HttpReferer,
            RequestUri: FsCurrentAnalytics.RequestUri,
            UserAgent: FsCurrentAnalytics.UserAgent,
            Visitor: FsCurrentAnalytics.Visitor
        };
        this.AddToQueue(args, finish);
    };
};
jQuery(document).ready(function(){
   FsAnalytics.PageView(); 
});