<?php

class FsConsultationView
{
    private static $TextInputType = 1;
    private static $TextAreaType = 2;
    private static $CheckInputsType = 3;
    private static $RadioInputsType = 4;
    
    public static $InsideLabelType = 1;
    public static $OutsideLabelType = 2;
    
    private $template = null;
    
    public function __construct()
    {
        add_shortcode( 'fs_consultation', array(&$this, 'RenderView' ));   
        add_action('wp_ajax_load_consultation_slots', array(&$this, 'LoadConsultationSlots'));
        add_action('wp_ajax_nopriv_load_consultation_slots', array(&$this, 'LoadConsultationSlots'));
    }
    
    function RenderView($atts)
    {        
	extract( shortcode_atts( array(
            'form' => ''
	), $atts ) );
        global $fs_forms_url;
        global $fs_visitor;
        global $is_IE;
        
        wp_enqueue_script('jquery-ui-1.10.3.custom.min.js');  
        wp_enqueue_script('jquery.form.js');   
        wp_enqueue_script('jquery.validate.min.js');   
        wp_enqueue_script('fs-consultation-view-script.js', $fs_forms_url.'script/fs-consultation-view-script.js', array('jquery-ui-1.10.3.custom.min.js'));
        wp_localize_script('fs-consultation-view-script.js', 'FsCurrentConsultation', array(  
            'FsAjax' => admin_url( 'admin-ajax.php' )
        ));
        if ( $is_IE ) 
        {
            wp_enqueue_script('jquery.placeholder');
            wp_enqueue_script('fs-ie-fix');
        }
        $fields = array (
            "Form" => $form,
        );
        $json = FsForms::CurlGetContents(FsForms::$form_schema_script, $fields);
        $schema = json_decode($json);
        
        if($schema->template != null)
        {
            $this->template = $schema->template;
        }
        
        $html = '<div id="fs-consultation-container-'.$schema->recnum.'" class="fs-consultation-container" data-form="'.$schema->recnum.'">    
            <p><a href="#" class="fs-consultation-button fs-consultation-phone-call" data-method="Phone Call">Short Phone Call</a></p>
            <p><a href="#" class="fs-consultation-button fs-consultation-video-chat" data-method="Video Chat">Short Video Chat</a></p>
            <p><a href="#" class="fs-consultation-button fs-consultation-on-site" data-method="On Site">On Site Meeting</a></p>                                   
        </div>
        <div id="fs-consultation-modal-'.$schema->recnum.'" class="fs-consultation-modal" style="display: none;" title="Schedule Expert Consultation" data-form="'.$form.'">
            <form id="fs-consultation-form-'.$schema->recnum.'" class="fs-consultation-form" action="'.FsForms::$form_processor_script.'" method="post">
                <input type="hidden" name="form" value="'.$schema->recnum.'" />
                <input type="hidden" name="type" value="2" />
                <input type="hidden" name="ip_address" value="'.$_SERVER['REMOTE_ADDR'].'" />
                <input type="hidden" name="from_url" value="'.$_SERVER['REQUEST_URI'].'" />     
                <input type="hidden" name="visitor" value="'.$fs_visitor.'" />
                <input type="hidden" name="method" value="" />
                <p style="display: none;">
                    <input type="text" name="username" />
                </p>
                <div class="fs-row">
                    <div class="fs-col fs-col-12">
                        <h3>Please Select A Time For Appointment</h3>
                    </div>
                </div>
                <div class="fs-row">
                    <div class="fs-col fs-col-6">
                        <div class="fs-consultation-datepicker"></div>                        
                    </div>
                    <div class="fs-col fs-col-6">
                        <div class="fs-consultation-slot-loader fs-loader"></div>
                        <div class="fs-consultation-slots">Please select a date from the calendar...</div>
                    </div>
                </div>
                <div class="fs-row">
                    <div class="fs-col fs-col-6">
                        <h3>Method: <span class="fs-consultation-type"></span></h3>
                    </div>
                    <div class="fs-col fs-col-6">
                        <p>Please leave your contact information.</p>
                        ';
                        foreach($schema->fields as $field)
                        {
                            $html .= $this->render_field($field);
                        } 
                        $html .= '                        
                        <div class="fs-form-row fs-consultation-form-result"></div>
                        <div class="fs-consultation-form-loader fs-loader"></div>
                    </div>
                </div>
            </form>
            <script type="text/javascript">
            jQuery(document).ready(function() {
                FsAnalytics.FormView('.$schema->recnum.');';
                foreach($schema->fields as $field)
                {
                    if($field->type == self::$TextInputType)
                    {
                        $html.='jQuery(\'#fs-lead-form-'.$schema->recnum.' input[name="'.$field->name.'"]\').change(function(){
                            var value = jQuery(\'#fs-lead-form-'.$schema->recnum.' input[name="'.$field->name.'"]\').val();
                            FsAnalytics.FormUpdate('.$field->recnum.', value);
                        });';
                    }
                    else if($field->type == self::$TextAreaType)
                    {
                        $html.='jQuery(\'#fs-lead-form-'.$schema->recnum.' textarea[name="'.$field->name.'"]\').change(function(){
                            var value = jQuery(\'#fs-lead-form-'.$schema->recnum.' textarea[name="'.$field->name.'"]\').val();
                            FsAnalytics.FormUpdate('.$field->recnum.', value);
                         });';
                    }
                }

                $html .= '
                jQuery("#fs-consultation-form-'.$schema->recnum.'").validate({
                    rules: {';                    
                $rules = array();
                foreach($schema->fields as $field)
                {
                    $rule =  $field->name.': {';
                    if($field->required==1)
                    {
                         $rule .= 'required: true';
                    }
                    $rule .= '}';
                    $rules[] = $rule;
                }
                $html .= implode(',',$rules);  
                $html .= '},
                    messages: {';
                $messages = array();
                foreach($schema->fields as $field)
                {
                    if($field->required==1)
                    {
                        $messages[] = $field->name.': "*"';
                    }
                }
                $html .= implode(',', $messages);
                $html .= '},
                    submitHandler: function(form) {
                        jQuery(form).ajaxSubmit({
                                target: "#fs-consultation-form-'.$schema->recnum.' .fs-consultation-form-result",                            
                                beforeSubmit: function() {
                                    jQuery("#fs-consultation-form-'.$schema->recnum.' .fs-consultation-form-loader").show();
                                },
                                success: function() {
                                    jQuery("#fs-consultation-form-'.$schema->recnum.' .fs-consultation-form-loader").hide();
                                },
                                error: function(jqXHR, textStatus, errorThrown) {
                                    jQuery("#fs-consultation-form-'.$schema->recnum.' .fs-consultation-form-loader").hide();
                                    jQuery("#fs-consultation-form-'.$schema->recnum.' .fs-consultation-form-result").html(jqXHR.status+"<br/>"+jqXHR.statusText);
                              }
                        });
                    }
                });
            });
            </script>
        </div>  
        ';
        return $html;
    }
    
    public function LoadConsultationSlots()
    {
        global $wpdb;
        try
        {
            $date = new DateTime($_POST['Date']);
            $fields = array (
                "Form" => esc_attr($_POST['Form']),
                "Date" => $date->format('Y-m-d')
            );            
            $json = FsForms::CurlGetContents(FsForms::$form_calendar_script, $fields);
            $schema = json_decode($json);
            if(strlen($schema->error)>0)
            {
                throw new Exception($schema->error);
            }
            if(!isset($schema->calendar))
            {
                throw new Exception('Calendar is Invalid!');
            }
            if(count($schema->calendar->slots)==0)
            {
                throw new Exception('There are no slots available this day!');
            }
            ?>
            <input type="hidden" name="consultation_date" value="<?php echo $date->format('Y-m-d'); ?>" />
            <table class="fs-consultation-slots-table">
                <thead>
                    <tr><th>Start Time</th><th>End Time</th><th></th></tr>
                </thead>
                <tbody>
                    <?php
                    foreach($schema->calendar->slots as $slot)
                    {
                        $start = new DateTime($slot->start);
                        $end = new DateTime($slot->end);
                        ?>
                        <tr>
                            <td><?php echo $start->format('g:i A'); ?></td>
                            <td><?php echo $end->format('g:i A'); ?></td>
                            <td><input type="checkbox" name="consultation_slot[]" value="<?php echo $slot->recnum; ?>" /></td>
                        </tr>
                        <?php
                    }
                    ?>
                </tbody>
            </table>
            <script type="text/javascript">
            fs_consultation_init_slots();
            </script>
            <?php
        } 
        catch (Exception $ex)
        {
            echo '<span style="color: red;">' . $ex->getMessage() . '</span>';
        }
        die();
    }
    
    
    private function render_field($field)
    {
        $html = '';
        switch($field->type)
        {
            case self::$TextInputType:
                $html = $this->render_text_input_field($field);
                break;
            case self::$TextAreaType:
                $html = $this->render_textarea_field($field);
                break;
            case self::$CheckInputsType:
                $html = $this->render_checks_input_field($field);
                break;
            case self::$RadioInputsType:
                $html = $this->render_radios_input_field($field);
                break;
        }
        return $html;
    }
    private function render_text_input_field($field)
    {
        $html = '<div class="fs-form-row">';
        if($this->template != null && $this->template->label_type == self::$OutsideLabelType)
        {
            $html .= '<label for="'.$field->name.'-'.$field->recnum.'-input">'.$field->title.'</label><input type="text" id="'.$field->name.'-'.$field->recnum.'-input" name="'.$field->name.'" />';
        }
        else
        {
            $html .= '<input type="text" id="'.$field->name.'-'.$field->recnum.'-input" name="'.$field->name.'" placeholder="'.$field->title.'" />';
        }    
        $html .= '</div>';
        return $html;
    }
    private function render_textarea_field($field)
    {
        $html = '<div class="fs-form-row">';
        if($this->template != null && $this->template->label_type == self::$OutsideLabelType)
        {
            $html .= '<label for="'.$field->name.'-'.$field->recnum.'-textarea">'.$field->title.'</label><textarea id="'.$field->name.'-'.$field->recnum.'-textarea" name="'.$field->name.'"></textarea>';
        }
        else
        {
            $html .= '<textarea id="'.$field->name.'-'.$field->recnum.'-textarea" name="'.$field->name.'" placeholder="'.$field->title.'"></textarea>';
        }
        $html .= '</div>';
        return $html;
    }
    private function render_checks_input_field($field)
    {
        $html = '<div class="fs-form-row fs-checks-row">
            <label>'.$field->title.'</label>
            <div class="fs-check-options">';
            $i=0;
            foreach($field->meta->select_options as $option)
            {
                $checked = '';
                $html .= '<input type="checkbox" name="'.$field->name.'[]" value="'.$option->value.'" '.$checked.' />'.$option->label.'<br/>';
                $i++;
            }            
            $html .= '</div>
        </div>';
        return $html;
    }
    private function render_radios_input_field($field)
    {
        $html = '<div class="fs-form-row fs-radios-row">
            <label>'.$field->title.'</label>
            <div class="fs-radio-options">';            
            foreach($field->meta->select_options as $option)
            {
                $checked = '';
                $html .= '<input type="radio" name="'.$field->name.'" value="'.$option->value.'" '.$checked.' />'.$option->label.'<br/>';
            }            
            $html .= '</div>
        </div>';
        return $html;
    }
    
    
}